using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using NHibernate.Linq.Visitors;

namespace NHibernate.Linq
{
	public class ContextualExpressionTreeVisitor : NhExpressionTreeVisitor
	{
		private Stack<IVisitorContext> _contextStack;

		public ContextualExpressionTreeVisitor()
		{
			_contextStack = new Stack<IVisitorContext>();
			_contextStack.Push(null);
		}

		public override Expression VisitExpression(Expression expression)
		{
			if (expression == null)
				return null;

			IVisitorContext context = new VisitorContext(_contextStack.Peek(), expression);
			_contextStack.Push(context);

			Expression result = base.VisitExpression(expression);

			_contextStack.Pop();

			return result;
		}

		protected IVisitorContext Context
		{
			get { return _contextStack.Peek(); }
		}
	}
}
